/*
 *	Copyright (C) 2001 Jan Bobrowski <jb@wizard.ae.krakow.pl>
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	version 2 as published by the Free Software Foundation.
 */

#include "toico.h"
#include <png.h>

int ispng(u8 *p)
{
	return !png_sig_cmp(p, 0, SIGN_SIZE);
}

void readpng(struct img *img, FILE *f, u8 sig[SIGN_SIZE])
{
	png_structp png;
	png_infop pi, pe;
	int cm;

	png = png_create_read_struct(PNG_LIBPNG_VER_STRING, 0, 0, 0);
	if(!png)
		goto pngerr;
	pi = png_create_info_struct(png);
	if(!pi)
		goto pngerr;
	pe = png_create_info_struct(png);
	if(!pe)
		goto pngerr;
/*	if(setjmp(png->jmpbuf))
		return;*/
	png_init_io(png, f);
	png_set_sig_bytes(png, SIGN_SIZE);
	png_read_info(png, pi);

	img->w = png_get_image_width(png, pi);
	img->h = png_get_image_height(png, pi);
	cm = png_get_color_type(png, pi);

	png_set_expand(png);
	png_set_strip_16(png);
	png_set_invert_alpha(png);
#ifndef BE_ORDER
	png_set_bgr(png);
	png_set_filler(png, 0, PNG_FILLER_AFTER);
#else
	png_set_filler(png, 0, PNG_FILLER_BEFORE);
#endif
	alloc_im(img);
	{
		png_bytep *rows = malloc(img->h * sizeof *rows);
		u32 *p = img->im;
		int y = 0;
		do {rows[y++] = (png_bytep)p; p += img->w;} while(y < img->h);
		png_read_image(png, rows);
		free(rows);
	}
	png_read_end(png, pe);
	png_destroy_read_struct(&png, &pi, &pe);
	return;
pngerr:
	errx(1, "PNG library error");
}
